<?php
/*
Plugin Name: Restore Automatic Update (ru_RU)
Plugin URI: http://ru.forums.wordpress.org/topic/7292
Description: Allows to update any outdated Russian WordPress package to the latest release from ru.wordpress.org.
Author: Sergey Biryukov
Author URI: http://ru.wordpress.org/
Version: 0.2
*/ 

function rau_welcome_back($options) {
	foreach ( (array) $options->updates as $key => $value ) {
		$value->url = strpos($value->url, 'wordpress.org') === false ? 'http://ru.wordpress.org/' : $value->url;
		$value->package = preg_replace('/http:\/\/.*\/(wordpress-.*-ru_RU\.zip)+?/', 'http://ru.wordpress.org/$1', $value->package);
		$options->updates[$key] = $value;
	}
	return $options;
}
add_filter('option_update_core', 'rau_welcome_back');
add_filter('transient_update_core', 'rau_welcome_back');
add_filter('site_transient_update_core', 'rau_welcome_back');

function rau_reinstate_api_server($response = false, $args, $url) {
	if ( strpos($url, 'mywordpress.ru') === false )
		return $response;

	$mywordpress_api = array(
		'http://mywordpress.ru/api/update.php',
		'http://mywordpress.ru/api/update15.php'
	);
	$original_api = array(
		'http://api.wordpress.org/core/version-check/1.3/',
		'http://api.wordpress.org/core/version-check/1.5/'
	);
	$url = str_replace($mywordpress_api, $original_api, $url);

	remove_filter('pre_http_request', 'rau_reinstate_api_server', 10, 3);	
	$response = wp_remote_get($url, $args);

	return $response;
}
add_filter('pre_http_request', 'rau_reinstate_api_server', 10, 3);
?>